{System/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR iLoop                         AS INTEGER   NO-UNDO.
DEF VAR iModulo                       AS INTEGER   NO-UNDO.
DEF VAR iSeqnr                        AS INTEGER   NO-UNDO.
DEF VAR iAddressNr                    AS INTEGER   NO-UNDO.

DISABLE TRIGGERS FOR LOAD OF dp-control.
DISABLE TRIGGERS FOR LOAD OF aa-address.

DEFINE BUFFER b-aa-control FOR aa-control.
DEFINE BUFFER b-aa-address FOR aa-address.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert SF Sync. errors"
  cTable   = "dp-control"
  iTotal   = 0
  iDone    = 0
  iModulo  = 0
  .



/* procedure naam dp-deactivate-depot.p omzetten */
RUN 4glprocs.

PROCEDURE 4glprocs :

  DISABLE TRIGGERS FOR LOAD OF aa-edi-system.
  DEFINE BUFFER b-aa-edi-system FOR aa-edi-system.

  FIND b-aa-edi-system WHERE
         b-aa-edi-system.system_type = '4GL_PROCEDURE'
    AND  b-aa-edi-system.system_code = 'DEPOT-DEACTIVATE'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-edi-system
  THEN DO:
    CREATE b-aa-edi-system.
    ASSIGN
    b-aa-edi-system.system_type = '4GL_PROCEDURE'
    b-aa-edi-system.system_code = 'DEPOT-DEACTIVATE'
    .
  END.
  ASSIGN
    b-aa-edi-system.des = 'Deactive inactive depots'
    b-aa-edi-system.edit_parameter_proc = 'DP/proc/dp-deactivate-depot.p'
    .

  FIND b-aa-edi-system WHERE
         b-aa-edi-system.system_type = '4GL_PROCEDURE'
    AND  b-aa-edi-system.system_code = 'STOCK-DEACTIVATE'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-edi-system
  THEN DO:
    CREATE b-aa-edi-system.
    ASSIGN
    b-aa-edi-system.system_type = '4GL_PROCEDURE'
    b-aa-edi-system.system_code = 'STOCK-DEACTIVATE'
    .
  END.
  ASSIGN
    b-aa-edi-system.des = 'Deactive inactive stocks'
    b-aa-edi-system.edit_parameter_proc = 'DP/proc/dp-deactivate-stock.p'
    .


  FIND b-aa-edi-system WHERE
         b-aa-edi-system.system_type = '4GL_PROCEDURE'
    AND  b-aa-edi-system.system_code = 'TYPE-DEACTIVATE'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-edi-system
  THEN DO:
    CREATE b-aa-edi-system.
    ASSIGN
    b-aa-edi-system.system_type = '4GL_PROCEDURE'
    b-aa-edi-system.system_code = 'TYPE-DEACTIVATE'
    .
  END.
  ASSIGN
    b-aa-edi-system.des = 'Deactive inactive containertypes'
    b-aa-edi-system.edit_parameter_proc = 'DP/proc/dp-deactivate-containertype.p'
    .

  FIND b-aa-edi-system WHERE
         b-aa-edi-system.system_type = '4GL_PROCEDURE'
    AND  b-aa-edi-system.system_code = 'TYPECUST-DEACTIVATE'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-edi-system
  THEN DO:
    CREATE b-aa-edi-system.
    ASSIGN
    b-aa-edi-system.system_type = '4GL_PROCEDURE'
    b-aa-edi-system.system_code = 'TYPECUST-DEACTIVATE'
    .
  END.
  ASSIGN
    b-aa-edi-system.des = 'Deactive inactive containertypes (cust)'
    b-aa-edi-system.edit_parameter_proc = 'DP/proc/dp-deactivate-containertype-cust.p'
    .

END PROCEDURE.



/* Salesforce errors werden eerst in aa-control records opgeslagen, nu een nieuw veld. */
FOR EACH b-aa-control WHERE
         b-aa-control.controlcode BEGINS "SF-ERRORS-"
         EXCLUSIVE-LOCK:

  iAddressNr = INT(ENTRY(3, b-aa-control.controlcode, "-")).

  FIND b-aa-address WHERE
       b-aa-address.addressnr = iAddressNr
       EXCLUSIVE-LOCK NO-ERROR.
  IF AVAILABLE b-aa-address
  THEN DO:
    ASSIGN b-aa-address.external_app_syncerror = b-aa-control.list.
    DELETE b-aa-control.
  END.

  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

END.

iTotal = iDone.
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).



